//
// Created by zx on 2020/7/7.
//

#ifndef NNXX_TESTS_TAKEPROCESS_H
#define NNXX_TESTS_TAKEPROCESS_H
#include <parkspace_allocation_message.pb.h>
#include "error_code.h"
#include "TaskQueue/BaseTask.h"

class PickupProcessTask :public tq::BaseTask{
public:
    PickupProcessTask();
    virtual  ~PickupProcessTask();
    Error_manager init_task(unsigned int command_id, unsigned int terminor_id,message::Car_info car_info);

    /*
     * 查询车位
     */
    Error_manager search_space();
protected:
    virtual void Main();

    /*
     * 执行取车动作请求,并等待执行完成
     */
    Error_manager pickup_step();

    /*
     * 等待车辆离开
     */
    Error_manager wait_for_leave_step();

    /*
     * 清除车位表中对应的车位
     */
    Error_manager release_space_step();

protected:
    unsigned int                m_command_id;
    unsigned int                m_terminor_id;
    message::Car_info           m_car_info;          //当前流程的车辆信息

private:
    //查询到的车位信息
    message::Parkspace_search_response_msg                  m_parcspace_search_response_msg;

};


#endif //NNXX_TESTS_TAKEPROCESS_H
